
myFunction<-function(result, Report, f, soln.y, x1, x2, x3, x4, y1, y2, y3, y4){
  
  M1 <- 176
  fileout <- file("./results/recommendations.txt")
  stations <-file("./results/recommendedStationIDs.txt")
  out <- c()
  idOut <- c()
  if (result[["status"]] == "infeasible"){
    out <- append(out, c("No solution is found with the current budget. Please increase the budget to find a feasible solution.", "\n"))
  }else if(result[["status"]] == "opt"){out <- append(out, c("This problem has an optimal solution. Please reduce the budget used to see the optimal solution.", "\n"))
  }else{
    
    if (nrow(y1)==0 & nrow(y2)==0 & nrow(y3)==0 & nrow(y4)==0 )
      out <- append(out, c("No change is necessary"))
    else{
      
      if (Report ==1){
        if (nrow(y1)>0)
          for (j in 1:nrow(y1))
          {out <- append(out, sprintf("Build a new facility near %s with no service. Add %d parking spaces for $%.2f.\n", y1[j,4], y1[j,7], y1[j,6]))
            idOut <- append(idOut, c(y1[j,4]))}
        if (nrow(y2)>0)
          for (j in 1:nrow(y2))
          {out <- append(out, sprintf("Build a new facility near %s with partial service. Add %d parking spaces for $%.2f.\n", y2[j,4], y2[j,7], y2[j,6]))
            idOut <- append(idOut, c(y2[j,4]))}
        if (nrow(y3)>0)
          for (j in 1:nrow(y3))
          {out <- append(out, sprintf("Build a new facility near %s with full service. Add %d parking spaces for $%.2f.\n", y3[j,4], y3[j,7], y3[j,6]))
            idOut <- append(idOut, c(y3[j,4]))}
        if (nrow(y4)>0)
          for (j in 1:nrow(y4))
          {out <- append(out, sprintf("Expand the existing facility, %s. Add %d parking spaces for $%.2f. \n", y4[j,4], y4[j,7], y4[j,6]))
            idOut <- append(idOut, c(y4[j,4]))}
      
      
      
        if (nrow(x1)>0)
          for (j in 1:nrow(x1))
            out <- append(out, sprintf("%.1f%% of the demand for %s is satisfied by building the new facility %s with no service.\n", round(x1[j,4]*100, digits=2), as.character(x1[j,6]), as.character(x1[j,5])))
        if (nrow(x2)>0)
          for (j in 1:nrow(x2))
            out <- append(out, sprintf("%.1f%% of the demand for facility %s is satisfied by building the new facility %s with partial service.\n", round(x2[j,4]*100, digits=2), as.character(x2[j,6]), as.character(x2[j,5])))
        if (nrow(x3)>0)
          for (j in 1:nrow(x3))
            out <- append(out, sprintf("%.1f%% of the demand for facility %s is satisfied by building the new facility, %s with full service.\n", round(x3[j,4]*100, digits=2), as.character(x3[j,6]), as.character(x3[j,5])))
        if (nrow(x4)>0)
          for (j in 1:nrow(x4))
            out <- append(out, sprintf("%.1f%% of the demand for facility %s is satisfied by expanding the existing facility, %s.\n", round(x4[j,4]*100, digits=2), as.character(x4[j,6]), as.character(x4[j,5])))
      }
      
      
      else {
        if (nrow(y1)>0)
          for (j in 1:nrow(y1))
            {out <- append(out, sprintf("Build a new facility near the %s with no service. Add %d parking spaces for $%.2f.\n", y1[j,5], y1[j,7], y1[j,6]))
              idOut <- append(idOut, c(y1[j,4]))}
        if (nrow(y2)>0)
          for (j in 1:nrow(y2))
            {out <- append(out, sprintf("Build a new facility near the %s with partial service. Add %d parking spaces for $%.2f.\n", y2[j,5], y2[j,7], y2[j,6]))
              idOut <- append(idOut, c(y2[j,4]))}
        if (nrow(y3)>0)
          for (j in 1:nrow(y3))
            {out <- append(out, sprintf("Build a new facility near the %s with full service. Add %d parking spaces for $%.2f.\n", y3[j,5], y3[j,7], y3[j,6]))
              idOut <- append(idOut, c(y3[j,4]))}
        if (nrow(y4)>0)
          for (j in 1:nrow(y4))
            {out <- append(out, sprintf("Expand the existing facility, %s. Add %d parking spaces for $%.2f. \n", y4[j,5], y4[j,7], y4[j,6]))
              idOut <- append(idOut, c(y4[j,4]))}
        
        
        
        if (nrow(x1)>0)
          for (j in 1:nrow(x1))
            out <- append(out, sprintf("%.1f%% of the demand for the %s is satisfied by building a new facility near the %s with no service.\n", round(x1[j,4]*100, digits=2), as.character(x1[j,8]), as.character(x1[j,7])))
        if (nrow(x2)>0)
          for (j in 1:nrow(x2))
            out <- append(out, sprintf("%.1f%% of the demand for the %s is satisfied by building a new facility near the %s with partial service.\n", round(x2[j,4]*100, digits=2), as.character(x2[j,8]), as.character(x2[j,7])))
        if (nrow(x3)>0)
          for (j in 1:nrow(x3))
            out <- append(out, sprintf("%.1f%% of the demand for the %s is satisfied by building a new facility near the %s with full service.\n", round(x3[j,4]*100, digits=2), as.character(x3[j,8]), as.character(x3[j,7])))
        if (nrow(x4)>0)
          for (j in 1:nrow(x4))
            out <- append(out, sprintf("%.1f%% of the demand for the %s is satisfied by expanding the existing facility, %s.\n", round(x4[j,4]*100, digits=2), as.character(x4[j,8]), as.character(x4[j,7])))
        
      }
    }
}

  a = 0;
  
  for (i in 1:M1) {
    a = a + f[i]*soln.y[i,3]
  }
  
  if (result[["status"]] != "opt"){
    out <- append(out, sprintf("Budget to spend on the new and expanded facilities is $%.2f.\n", a))
    out <- append(out, sprintf("This solution is %s.\n", result$status))
    out <- append(out, sprintf("The average percentage of met demand is %.1f%%.\n", round((result$objective_value)*100, digits=2)))
  } else {
    out <- append(out, c("The average percentage of met demand with this budget is 100%", "\n"))
  }

  writeLines(out, fileout)
  writeLines(idOut, stations)
  close(fileout)
  close(stations)
}

